unit MainWndU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ToolWin, ComCtrls, JMMFile, Spin, StdCtrls, ExtCtrls;

type
  TMainWnd = class(TForm)
    mmSourse: TJMemMapFile;
    mmDest: TJMemMapFile;
    ToolBar1: TToolBar;
    sbExit: TSpeedButton;
    sbGo: TSpeedButton;
    sbStop: TSpeedButton;
    sbSeparator: TSpeedButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    pnInfo: TPanel;
    Panel3: TPanel;
    chbShowInfo: TCheckBox;
    sedCount: TSpinEdit;
    Label3: TLabel;
    edDestinationName: TEdit;
    Label2: TLabel;
    Label1: TLabel;
    edSourseName: TEdit;
    sbChoosSourse: TSpeedButton;
    sbCooseDest: TSpeedButton;
    Label4: TLabel;
    lbSimbNumS: TLabel;
    Label5: TLabel;
    lbStrNum: TLabel;
    Label6: TLabel;
    lbSimbNumD: TLabel;
    procedure sbChoosSourseClick(Sender: TObject);
    procedure sbCooseDestClick(Sender: TObject);
    procedure sbExitClick(Sender: TObject);
    procedure sbGoClick(Sender: TObject);
    procedure sbStopClick(Sender: TObject);
    procedure chbShowInfoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  protected
    FRealDFS      : DWORD;
    FStop         : boolean;
    FShowInfo     : boolean;

    procedure Action;                                                      virtual;
    procedure EndAction;                                                   virtual;

    procedure SetActivity(Value : boolean);                                virtual;
  public
    { Public declarations }
  end;

var
  MainWnd: TMainWnd;

implementation

{$R *.DFM}
procedure TMainWnd.Action;
var
   IsCopy : boolean;
   i, CurSimb, CurStr : DWORD;
   j : integer;

begin
   IsCopy := true;
   j := 1;
   FStop := false;
   CurStr := 1;
   CurSimb:= 0;

   for i := mmSourse.FirstIndex to mmSourse.FileSize + (mmSourse.FirstIndex - 1) do begin
      if IsCopy then
         if j <= sedCount.Value then begin
            inc(FRealDFS);
            mmDest.AsChar[FRealDFS] := mmSourse.AsChar[i];
            inc(j);
            inc(CurSimb);
         end
         else begin
            IsCopy := false;
            case mmDest.AsChar[FRealDFS] of
              #$0d : begin
                 inc(FRealDFS);
                 mmDest.AsChar[FRealDFS] := #$0a;
              end;
              #$0a : ;
              else begin
                 inc(FRealDFS);
                 mmDest.AsChar[FRealDFS] := #$0d;
                 inc(FRealDFS);
                 mmDest.AsChar[FRealDFS] := #$0a;
              end;
            end;
         end;
      if i > 1 then
         if (mmSourse.AsChar[i] = #$0a) and(mmSourse.AsChar[i-1] = #$0d) then begin
            IsCopy := true;
            j := 1;
            inc(CurStr);
         end;
      Application.ProcessMessages;
      if FShowInfo then begin
         lbStrNum.Caption := inttostr(CurStr);
         lbSimbNumD.Caption := inttostr(CurSimb);
         lbSimbNumS.Caption := inttostr(i);
      end;

      if FStop = true then
         exit;
   end;
end;

procedure TMainWnd.EndAction;
begin
   mmSourse.Active := false;

   mmDest.Active := false;

   mmDest.SetFileLength(FRealDFS);
end;

procedure TMainWnd.SetActivity(Value : boolean);
begin
   edDestinationName.Enabled := Value;
   sbChoosSourse.Enabled := Value;
   sbChoosSourse.Enabled := Value;
   sbExit.Enabled        := Value;
   sbGo.Enabled          := Value;
   edSourseName.Enabled  := Value;
   sedCount.Enabled      := Value;
   Label1.Enabled        := Value;
   Label2.Enabled        := Value;
   Label3.Enabled        := Value;
   sbCooseDest.Enabled   := Value;
   sbStop.Enabled        := not Value;
end;

procedure TMainWnd.FormCreate(Sender: TObject);
begin
   FShowInfo := false;

   lbStrNum.Caption := '';
   lbSimbNumD.Caption := '';
   lbSimbNumS.Caption := '';

end;

procedure TMainWnd.sbChoosSourseClick(Sender: TObject);
begin
   if OpenDialog1.Execute then begin
      edSourseName.Text := OpenDialog1.FileName;
      mmSourse.FileName := OpenDialog1.FileName;
   end;
end;

procedure TMainWnd.sbCooseDestClick(Sender: TObject);
begin
   if SaveDialog1.Execute then begin
      edDestinationName.Text := SaveDialog1.FileName;
      mmDest.FileName := SaveDialog1.FileName;
   end;
end;

procedure TMainWnd.sbExitClick(Sender: TObject);
begin
   Close;
end;

procedure TMainWnd.sbGoClick(Sender: TObject);
begin
   try
      mmSourse.Active := true;

      mmDest.AddSize := 0;
      try
         mmDest.Active  := true;
      except
         on e:Exception do
            if mmDest.LastError <> errZeroLength then
               raise Exception.Create(e.Message)
      end;
      FRealDFS       := mmDest.FileSize;
      mmDest.Active  := false;
      mmDest.AddSize := mmSourse.FileSize;
      mmDest.Active  := true;
   except
      on e: Exception do begin
         MessageDlg(e.message, mtError, [mbOk], 0);
         mmSourse.Active := false;
         mmDest.Active   := false;
         exit;
      end;
   end;
   SetActivity(false);
   try
      Action;
   finally
      EndAction;
      SetActivity(true);
   end;
end;

procedure TMainWnd.sbStopClick(Sender: TObject);
begin
   FStop := true;
end;

procedure TMainWnd.chbShowInfoClick(Sender: TObject);
begin
   if chbShowInfo.Checked then begin
      FShowInfo := true;
      pnInfo.Visible := true;
   end
   else begin
      FShowInfo := false;
      pnInfo.Visible := false;
   end;
end;

end.
